%{
/*
 * The Termprocessor Kimwitu
 *
 * Copyright (c) 1991 University of Twente, Dept TIOS.
 * All rights reserved.
 *
 */
%}
%{
/*
 * kimwl.l
 */
#if ! (defined(lint) || defined(SABER) || defined(CODECENTER))
static char kimwl_lAccesSid[] = "@(#)$Id: kimwl.l,v 2.27 1996/06/06 12:29:01 belinfan Rel $";
#endif
%}
%{
/* comments to suppress known `errors' */
/*SUPPRESS 529*/ /* statement cannot be reached */
/*SUPPRESS  25*/ /* creating a bad pointer during initialization */
#if (defined(SABER) || defined(CODECENTER))
# define lint
#endif
%}
%{
/* WARNING: YYLMAX should be at least 500
 * (because some people write real specs ...)
 * use the BUFSIZ that is defined in <stdio.h> as #define BUFSIZ 1024
 * this is a no-op on a sun: sun's lex already defines #define YYLMAX BUFSIZ
 * however, on a hp we get problems: YYLMAX is defined as #define YYLMAX 200
 * first get rid of old value: #undef YYLMAX before #define YYLMAX 'our-value'
 */
#undef YYLMAX
#define YYLMAX BUFSIZ

/* WARNING: some lexers (like (some versions of?) flex) #define yywrap
 * which causes problems if we try to define a function for it.
 * So, we undef it if defined.
 */
#ifdef yywrap
# undef yywrap
#endif
%}

%{
/***************************************************************************/
/*
 * Name conventions: tokens and states are in CAPITALS
 * operators are capitalized
 *
 */
%}

%start NORMAL INCL INCLSTART CEXPR CEXPRDQ CEXPRSQ C
%{
#if defined(__STDC__)
# include <stdlib.h>
#endif
#include <string.h>

#include "k.h"
#include "kimwy.h"

static int cinit_nesting =0;
static int eat_comment KC__P(( int*, int, casestring ));
%}

%%
<NORMAL>[ \t]	 			{ ; }
<NORMAL>\n				{ pg_lineno++; }
<NORMAL>^\%view				{ return T_PERCENTVIEW; }
<NORMAL>^\%storageclass			{ return T_PERCENTSTORAGECLASS; }
<NORMAL>^\%\{[ \t]*			{ BEGIN INCLSTART; return T_INCLUDESTART; }
<INCLSTART>[_a-zA-Z][_a-zA-Z0-9]*	{ yylval.yt_casestring = mkcasestring(yytext); return T_ID;}
<INCLSTART>[ \t]			{ ; }
<INCLSTART>\n				{ pg_lineno++; BEGIN INCL; }
<INCL>[^%\n]+				{ yylval.yt_casestring = mkcasestring(yytext); return T_INCLUDE; }
<INCL>\%				{ yylval.yt_casestring = mkcasestring(yytext); return T_INCLUDE; }
<INCL>\n				{ pg_lineno++; return yytext[0]; }
<INCL>^\%\}\n				{ pg_lineno++; BEGIN NORMAL; return T_INCLUDEEND; }
<C,CEXPR>\/\*				{ int no_of_newlines = eat_comment(&pg_lineno, pg_lineno, pg_filename);
					          yylval.yt_int = no_of_newlines; return T_CNEWLINES;
					    }
<NORMAL,INCL,INCLSTART>\/\*		{ eat_comment(&pg_lineno, pg_lineno, pg_filename); }
<NORMAL>\-\>				{ return T_ARROW ;}
<NORMAL>default				{ return T_DEFAULT; }
<NORMAL>\-?[0-9]+			{ yylval.yt_int = atoi(yytext); return T_INT; }
<NORMAL>list				{ return T_LIST ;}
<NORMAL>static				{ return T_STATIC; }
<NORMAL>[_a-zA-Z][_a-zA-Z0-9]*	 	{ yylval.yt_casestring = mkcasestring(yytext); return T_ID ; }
<CEXPR>[^\n\\"';()$]+			{ yylval.yt_casestring = mkcasestring(yytext); return T_CEXPRESSION; }
<NORMAL,CEXPR>\$[0-9]+			{ yylval.yt_int = atoi(yytext+1); return T_DOLLARVAR; }
<NORMAL>\$\{				{ return T_UNPBLOCKSTART; }
<NORMAL>\$\}				{ return T_UNPBLOCKEND; }
<CEXPR>\$				{ yylval.yt_casestring = mkcasestring(yytext); return T_CEXPRESSION; }
<CEXPR,CEXPRDQ,CEXPRSQ,C>\n		{ pg_lineno++; return yytext[0]; }
<CEXPR,CEXPRDQ,CEXPRSQ>\\		{ yylval.yt_casestring = mkcasestring("\\"); return T_CEXPRESSION; }
<CEXPR,CEXPRDQ,CEXPRSQ>\\\\		{ yylval.yt_casestring = mkcasestring("\\\\"); return T_CEXPRESSION; }
<NORMAL,C,CEXPR>\"				{ BEGIN CEXPRDQ; return yytext[0]; }
<NORMAL,C,CEXPR>'				{ BEGIN CEXPRSQ; return yytext[0]; }
<CEXPR>;				{ BEGIN NORMAL; return yytext[0]; }
<CEXPR>\(				{ cinit_nesting++;  yylval.yt_casestring = mkcasestring("("); return T_CEXPRESSION; }
<CEXPR>\)				{ if (cinit_nesting == 0) {
					      BEGIN NORMAL; return yytext[0];
					} else {
					      cinit_nesting--; yylval.yt_casestring = mkcasestring(")"); return T_CEXPRESSION; }
					}
<CEXPRDQ>[^\n\\"]+			{ yylval.yt_casestring = mkcasestring(yytext); return T_CEXPRESSION; }
<CEXPRDQ>\"				{ BEGIN CEXPR; return yytext[0]; }
<CEXPRDQ>\\\"				{ yylval.yt_casestring = mkcasestring("\\\""); return T_CEXPRESSION; }
<CEXPRSQ>'				{ BEGIN CEXPR; return yytext[0]; }
<CEXPRSQ>\\'				{ yylval.yt_casestring = mkcasestring("\\'"); return T_CEXPRESSION; }
<CEXPRSQ>[^\n\\']+			{ yylval.yt_casestring = mkcasestring(yytext); return T_CEXPRESSION; }
<C>\$\$					{ yylval.yt_casestring = mkcasestring("$"); return T_CLINE; }
<C>\\\\					{ yylval.yt_casestring = mkcasestring("\\\\"); return T_CLINE; }
<C>\\					{ yylval.yt_casestring = mkcasestring("\\"); return T_CLINE ; }
<C>\$\{					{ yylval.yt_casestring = mkcasestring("{"); /*WARNING-NO LONGER SUPPORTED*/ return T_CLINE ; }
<C>\$\}					{ yylval.yt_casestring = mkcasestring("}"); /*WARNING-NO LONGER SUPPORTED*/ return T_CLINE ; }
<C>\$[0-9]*				{ if (strcmp(yytext, "$") == 0)
					      return yytext[0];
					  yylval.yt_int = atoi(yytext+1);
					  return T_DOLLARVAR;
					}
<C>[a-zA-Z_][_a-zA-Z0-9]*		{ if (strcmp(yytext, "foreach") ==0) {
					      return T_FOREACH;
					  } else if (strcmp(yytext, "with") ==0) {
					      return T_WITH;
					  } else {
					      yylval.yt_casestring = mkcasestring(yytext);
					      return T_CLINE ;
					  }
					}
<C>[^\n{}w/"'a-zA-Z_\$\\]+		{ yylval.yt_casestring = mkcasestring(yytext); return T_CLINE; }
<C>\/					{ yylval.yt_casestring = mkcasestring(yytext); return T_CLINE; }
<C>\/\*[ \t]*EMPTY[ \t]*\*\/		{ yylval.yt_casestring = mkcasestring(yytext); return T_CLINE; }
<C>\/\*[ \t]*NOTREACHED[ \t]*\*\/	{ yylval.yt_casestring = mkcasestring(yytext); return T_CLINE; }
<C>\/\*[ \t]*SUPPRESS[ \t]*[0-9]+[ \t]*\*\/		{ yylval.yt_casestring = mkcasestring(yytext); return T_CLINE; }
.					{ return yytext[0]; }

%%
void do_NORMAL()	{ BEGIN NORMAL; }
void do_CEXPR()		{ BEGIN CEXPR; }
void do_CEXPRDQ()	{ BEGIN CEXPRDQ; }
void do_CEXPRSQ()	{ BEGIN CEXPRSQ; }
void do_C()		{ BEGIN C; }

int yywrap()		{ return 1; }

static int eat_comment
#ifdef KC_USE_PROTOTYPES
 (int *pg_lineno, int start_lineno, casestring start_filename)
#else
 (pg_lineno, start_lineno, start_filename)
  int *pg_lineno;
  int start_lineno;
  casestring start_filename;
#endif
{
	char c1, c2;		/* comment string */
	int nest;
	int no_of_newlines = 0;
					
	for(nest=1, c2 = ' ';;){
		c1 = c2;
		c2 = input();
		if (c1 == '/' && c2 == '*')
			nest++;
		else if (c1 == '*' && c2 == '/')
			nest--;
		if (nest <= 0)
			break;
		if (c2 == '\n') {
			no_of_newlines++;
		} else if (c2 == 0) {
			v_report( Fatal( FileLine( start_filename, start_lineno ), Problem1S( "start of comment containing unexpected eof" )));
		}
	}
	*pg_lineno += no_of_newlines;
	return no_of_newlines;
}

#ifndef FLEX_SCANNER
void yyrestart( input_file ) FILE *input_file; {}
#endif
